--[[
Description: This plugin is part of the "Titan Panel [Currencies] Multi" addon. It shows your amount of Artifact Power.
Site: http://www.curse.com/addons/wow/titan-panel-currencies-multi
Author: Canettieri
Special Thanks to Eliote.
--]]

local ADDON_NAME, L = ...;
local ACE = LibStub("AceLocale-3.0"):GetLocale("Titan", true)
local version = GetAddOnMetadata(ADDON_NAME, "Version")
local ID = "TITAN_ARTFTM"
local ICON = "Interface\\Icons\\inv_scroll_05"
local artifactCount
local artifactMaximum
local artifactLevel
local artifactSpend
local weaponName
-----------------------------------------------
local function Util_StringComDefault(v,d)
	if not v then
		return d
	end

	return v
end
-----------------------------------------------
local function OnUpdate(self, id)
	if HasArtifactEquipped() then
	local itemID, altItemID, name, icon, totalXP, pointsSpent, quality, artifactAppearanceID, appearanceModID, itemAppearanceID, altItemAppearanceID, altOnTop = C_ArtifactUI.GetEquippedArtifactInfo();
  local numPointsAvailableToSpend, xp , xpForNextPoint = MainMenuBar_GetNumArtifactTraitsPurchasableFromXP(pointsSpent, totalXP);

	if artifactCount == totalXP and VT == xpForNextPoint and artifactLevel == pointsSpent and artifactSpend == numPointsAvailableToSpend or weaponName == name then return end
	artifactCount = totalXP
	artifactMaximum = xpForNextPoint
	artifactLevel = pointsSpent
	artifactSpend = numPointsAvailableToSpend
	weaponName = name

		TitanPanelButton_UpdateButton(id)
		return true
	end
end
-----------------------------------------------
local function GetButtonText(self, id)
	local XP = artifactCount
	local tolvl = artifactMaximum

	local weaponlvl = ""
	if artifactSpend == 0 or nil then
		weaponlvl = artifactLevel
	elseif
		artifactSpend > 0 then
			weaponlvl = artifactLevel.."-|cFFFF2e2e"..artifactSpend.."|r"
	end

		if HasArtifactEquipped() then
			return L["ArticaftTitle"]..": ", "|cFFFFFFFF[|r|cFF198ae0"..weaponlvl.."|cFFFFFFFF]|r|cFF69FF69 "..XP.."|r / |cFFFFFFFF"..tolvl
		else
			return L["noweapon"]
		end
	end
-----------------------------------------------
local function GetTooltipText(self, id)

	local tooltiptext = "\r\r"..L["ArticaftLevel"]..artifactLevel.."|r\r"..L["ArticaftSpend"]..artifactSpend.."|r\r"..L["ArticaftXP"]..artifactCount.."|r\r"..L["ArticafttoMaximum"]..artifactMaximum.."|r\r"..L["ArticafttoLvL"]..(artifactMaximum - artifactCount)


	return L["ArticaftName"].."|cFFe6cc80"..weaponName.."|r"..tooltiptext
end
-----------------------------------------------
local function PrepareMenu(self, id)
	TitanPanelRightClickMenu_AddTitle(TitanPlugins[id].menuText)
	TitanPanelRightClickMenu_AddToggleIcon(id)
	TitanPanelRightClickMenu_AddToggleLabelText(id)

	local info = UIDropDownMenu_CreateInfo();
	info.text = ACE["TITAN_CLOCK_MENU_DISPLAY_ON_RIGHT_SIDE"];
	info.func = function() TitanToggleVar(id, "DisplayOnRightSide"); TitanPanel_InitPanelButtons(id); end
	info.checked = TitanGetVar(id, "DisplayOnRightSide");
	UIDropDownMenu_AddButton(info);

	TitanPanelRightClickMenu_AddSpacer()
	TitanPanelRightClickMenu_AddCommand(ACE["TITAN_PANEL_MENU_HIDE"], id, TITAN_PANEL_MENU_FUNC_HIDE);
end
-----------------------------------------------
L.Elib({
	id = ID,
	name = L["mLegion"].." Titan|cFF66b1ea "..L["ArticaftTitle"].."|r",
	tooltip = L["ArticaftTitle"],
	icon = ICON,
	category = "Information",
	version = version.." alpha",
	getButtonText = GetButtonText,
	onUpdate = OnUpdate,
	getTooltipText = GetTooltipText,
	prepareMenu = PrepareMenu,
	savedVariables = {
		ShowIcon = 1,
		DisplayOnRightSide = false,
		ShowLabelText = false,
	}
})
